<?php

require('classes/utils.php');
require('vendor/DPZFlickr/Flickr.php');

use \DPZ\Flickr;

try {

	/*
	pre-conditions
	*/

	Utils::cURLcheckBasicFunctions();
	Utils::load_config();
	Utils::check_api_vars();

	/*
	determine callback-url
	*/

	$callback=sprintf('%s://%s:%d%s',
		(@$_SERVER['HTTPS'] == 'on') ? 'https' : 'http',
		$_SERVER['SERVER_NAME'],
		$_SERVER['SERVER_PORT'],
		$_SERVER['SCRIPT_NAME']
	);

	/*
	start authentication with DPZFlickr
	*/

	$flickr=new Flickr(API_KEY, API_KEY_SECRET, $callback);

	if (!$flickr->authenticate('read'))
		throw new Exception('DPZFlickr reported an error.');

	/*
	if we've made it until here,
	we should have received
	the oauth-tokens...
	*/

	$oauth_access_token=$flickr->getOauthData(Flickr::OAUTH_ACCESS_TOKEN);
	$oauth_access_token_secret=$flickr->getOauthData(Flickr::OAUTH_ACCESS_TOKEN_SECRET);

	if (empty($oauth_access_token) || empty($oauth_access_token_secret))
		throw new Exception('We didn\'t receive the oauth-tokens.');

		/*
		... and write them to the file
		*/

		$oauth_token_file=PHOTO_DIR.'oauth_token.php';

		Utils::define_constants_create_file($oauth_token_file, 'oauth_token', array('OAUTH_TOKEN' => $oauth_access_token, 'OAUTH_TOKEN_SECRET' => $oauth_access_token_secret));

	/*
	and finally kill the session
	*/

	$flickr->signOut();

	Utils::output_html_stub('Authorization complete. - You can now run FlickrMovr for all your photos. :)');
}

catch (Exception $e) {
	Utils::output_html_stub('Hmm, something went wrong: '.$e->getMessage());
}